var 
    C $C$,   N $N$, W_oil $W^{oil}$, D $D$, W,     // ( var for HH)1-5
    K $K$, Y_no $Y^{no}$, Nn $N^n$,                  //( var for SOE)6-8
    X $X$, P_k $P^k$, phi_func $\Phi(x)$, phi_func_der $\Phi\prime(x)$, x, // 9-13
    Y_H $Y^H$,                                               // (Final Good producers)14
     X1 $X^1$, X2 $X^2$, X3 $X^3$,                       //( var for retailers SOE)15-17
    NW $NW$, L,                                                        // (Wholesale banks)18-19
    K_G $K^G$,  B, G_c,G_p, T, trans $Tr$, S,                   // Government 20-26
    pi $\pi$,              // Prices and exchange rate  27
    prof_K $\Pi^K$,  prof_L $\Pi^L$, prof_D $\Pi^D$,    // profit 28-30
    R_D $R^D$, R , R_IB $R^{IB}$, R_k $R^{k}$, R_B $R^B$, R_CB $R^{CB}$, R_star $R^*$, //(Interest rates)31-37
    OR,                                                                //(OIL) 38
    Y_oil $Y^{oil}$,                                                    //39
    No $N^o$, K_oil $K^{oil}$, P_oil $P^{oil}$,           //40-42
    eps1 $\varepsilon^1$, eps2 $\varepsilon^2$,     //43-44
    shock_oil $\epsilon_{oil}$                                           //45
    GDP $Y$,                                         //46 
    F                                                                      //47
    B_CB $B^{CB}$                                                          //48 Claim CB on Banking
    mc , lambda_C $\lambda$ , pistar $\pi^*$ ,G ,P_no , prof_R$\Pi^R$ , shock_mon , pi_targer              //49-56 rigidity

%%%%%%%

; 
 


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// declaration of the stochastic shocks 
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

varexo ue1 $u^{e1}$, ue2 $u^{e2}$ , u_oil $u^{oil}$, u_mon $u^m$ ,u_pitarget $u^\pi$;// ,shock_mon $\epsilon^{m}$;

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// declaration of the different parameters
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load Parameters_1.mat;
load SS_oil_init.mat;
parameters

           beta_p $\beta$, sigma_c $\sigma_c$, alpha_H $\alpha_H$, eta_P $\eta_P$, phi $\phi$, xi_N $\xi_N$, // Household Parameters
           gamma_n $\gamma_n$, //  
           delta_k $\delta_k$, delta_o $\delta_o$,delta_g $\delta_g$, chi_x $\chi_x$, // Capital Producers
           alpha_p $\alpha_p$, theta $\theta$,
           eta_D $\eta^D$, eta_B $\eta^B$,  eta_L $\eta^L$,//
           epsilon_D $\epsilon^D$, kappa_D $\kappa^D$, // Deposit banks
           u,  // interest rate spread and subsidy
           nu $\nu$,  gamma_G $\gamma_G$, tau_w $\tau_w$,  tau_c $\tau_c$,tau_k $\tau_k$ ,tau_d $\tau_d$, rho_G $\rho_{G}$ // Government 
           rho_Rcb $\rho_R_{CB}$,  rho_pi $\rho_\pi$,  rho_gc $\rho_{gc}$,  rho_gp $\rho_{gp}$, 
           rho_eps1 $\rho^{\epsilon}_1$, rho_eps2 $\rho^{\epsilon}_2$, rho_eps3 $\rho^{\epsilon}_3$, rho_oil $\rho_{oil}$, gamma_o $\gamma_o$,
           rho_cap $\rho_\xi$, rho_Rstar $\rho_R^*$, rho_shock_oil $\rho_o$, rho_TR $\rho_\Gamma$, rho_M $\rho_M$, zeta $\zeta$, alpha_oil $\alpha_o$
           rho_y, chi $\chi$ ,  rho_BG $\rho_{BG}$, rho_mon $\rho_m$, rho_pitarget $\rho_{pitarget}$
           D_ss,B_ss,L_ss,P_oil_ss, G_ss,R_CB_ss,R_D_ss ,R_IB_ss,R_ss, OR_ss,pi_ss,GDP_ss,N_ss, Cof_R_star_ss, G_c_ss, G_p_ss , K_G_ss  
;

// define the parameters
 %% Run steadystate_Finder before run dynare file

for i=1:length(M_.params)
    deep_parameter_name = M_.param_names(i,:);
    eval(['M_.params(i)  = ' deep_parameter_name ' ;'])
end;


clear Parameters_1.mat;
clear SS_oil_init.mat;




//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//   the model 
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
model;  //  




// Household FOCs  
///////////////////////////////////////////////////////////////
xi_N * N^phi = C ^(-sigma_c) * W ;                                 // 1   C
1/R_D(1) = beta_p*  (C(+1)/C)^(-sigma_c) ;              //   2  R_D                           
C + D(1)   + T  = R_D   * D     + W * N + trans  + prof_K + prof_L + prof_D + prof_R ;        // 3 D  

// Intermediary producers  
////////////////////////////////////////////////////////////////////////
Y_no =   exp(eps1) * K   ^(gamma_n) * K_G(-1)^gamma_G * Nn^(1-gamma_n); //4  Y_no
W * Nn = (1-gamma_n) * P_no * Y_no ; //5   Nn
 

//Capital producers  
///////////////////////////////////////////////////////////////////////
x = X/X(-1);                                                                 // 6 x
phi_func = 1- chi_x/2*(x-1)^2/(x);                                           // 7 Cost function for capital producers
phi_func_der = - chi_x/2 *((x^2-1)/x^2); //chi_x*((x-1)/x)*(((x-1)/(2*x))-1);           // 8 Derivative of the cost function            
K(1) = (1-delta_k) * K   + phi_func * X;                                              // 9 Dyanmic of capital X
P_k*(x * phi_func_der + phi_func) +(1/R_D(1))*(P_k(+1)*phi_func_der(+1) * x(+1)^2 )  = 1; // 10 The FOC for capital producer   p_k 
prof_K = P_k * K(1)  - (1-delta_k) * P_k * K    - X;                                               // 11  Definition of capital producer profit

// Retailers  
///////////////////////////////////////////////////////////////////////
 
mc= (1/(1-gamma_n))^(1-gamma_n)*(1/gamma_n)^gamma_n * ((W^(1-gamma_n)* R^gamma_n)/(exp(eps1)* K_G(-1)^gamma_G));//12 W
lambda_C = C ^ (-sigma_c) ;   //13 lambda_C
X1 = lambda_C * mc     * Y_H + beta_p * alpha_p * (pi^chi/pi(+1))^(-theta)  * X1(+1);   // 14  firm's price setting  X1
X2 = lambda_C * pistar * Y_H + beta_p * alpha_p * (pi^chi/pi(+1))^(1-theta) * pistar/pistar(+1) * X2(+1); // 15 firm's price setting X2
theta * X1 = (theta-1) * X2;   // 16  firm's price setting  . mc
1 = alpha_p *(pi(-1)^chi/pi)^(1-theta)+(1-alpha_p)*pistar^(1-theta);  // 17   law of motion prices  pistar
X3 = alpha_p * (pi(-1)^chi/pi)^(-theta) * X3(-1) + (1-alpha_p) * pistar^(-theta);  //18   X3
X3 * Y_H = Y_no; //19    Market clearing of goods   Y_H
 
                                                      
// DEPOSIT BANK (2 Equations)
///////////////////////////////////////////////////////////////////////

R_IB = R_D + (kappa_D/epsilon_D)* (R_D/R_D(-1))* (R_D-R_D(-1))+ (kappa_D/2)* (R_D/R_D(-1)-1)^2   -  1/R_D *(kappa_D/epsilon_D)* (R_D(1)/R_D)* (R_D(1)/R_D-1)*(D(1)/D);//20 R_IB
prof_D = (R_IB - R_D) * D    - kappa_D/2 * (R_D /R_D(-1) - 1)^2 * D  ;                                     // 21 Deposit banks profit


//  Lending Banks  
///////////////////////////////////////////////////////////////////////
B(1) +   L  = D(1) +  B_CB  + NW  ; //22 B_CB
R_k = (gamma_n*P_no*Y_no + P_k * (1-delta_k) * K )/((1-u)* P_k(-1)  *K );      //23     K                                      
NW =     R_k  *L(-1)+ R_B   * B  -  R_IB  * D  - R_CB(-1) *  B_CB(-1)    - eta_D/2*(D  -D_ss)^2 - eta_B/2*(B  -B_ss)^2   - eta_L/2*(L(-1)-L_ss)^2  ;  //24 NW
L = P_k  * K(1)     ; //25 L
prof_L = NW;//26  

R_IB   = R_CB(-1) /(1+eta_D *(D  -D_ss));//27 R_CB
R_B    = R_CB(-1) /(1-eta_B*(B -B_ss));//28 R_B
R_k    = R_CB(-1) /(1-eta_L *(L(-1) -L_ss));  //29 R_k

 
// OIL Sector  
///////////////////////////////////////////////////////////////////////
P_oil =  (1-rho_oil)* P_oil_ss + rho_oil * P_oil(-1) + shock_oil;//32  
//log(P_oil) = rho_oil * log (P_oil(-1)) + shock_oil ; 
//P_oil = P_oil_ss + shock_oil ;//30
Y_oil = exp(eps2)*K_oil(-1)^(gamma_o)*No^(1-gamma_o);//31
OR = (1-alpha_oil) * P_oil * Y_oil - W_oil * No;//32
No = (1-alpha_oil) * (1-gamma_o) * P_oil * Y_oil/W_oil;//33
K_oil  = (1-delta_o) * K_oil(-1)  + alpha_oil * P_oil * Y_oil    ;//34
W_oil = W;//35

 
// OIL FUND  
///////////////////////////////////////////////////////////////////////
 
F +  B_CB =   (1-  rho_gp ) * F(-1) + (1 - nu) * OR +  R_CB(-1) *  B_CB(-1)  ; //  36 F
 
// Government 
///////////////////////////////////////////////////////////////////////

T + nu * OR + B(1)   + (rho_gp + R_star) * F(-1)  = R_B    * B + trans + G + S;//37 B
T = tau_k * ( prof_K + prof_L + prof_D + prof_R ) + tau_w * W * N + tau_c * C + tau_d * (R_D * D) ; // 38 Gov fiscal policy  T
trans = rho_TR    * nu * OR;//39
G_c =       G_c_ss ;     //40
G_p =       G_p_ss ;     //41
G_p = K_G - (1- delta_g) * K_G(-1) ; //42 K_G
S = u * R_k *P_k(-1) * K    ;//43
 ///////////////////////////////////////////////////////////////////////
// Central Bank  
///////////////////////////////////////////////////////////////////////
  
R_star = Cof_R_star_ss * ( R_CB - 1) ;  //44 R_star
R_CB - 1 = rho_Rcb * (R_CB(-1)-1) + (1-rho_Rcb) * ((R_CB_ss - 1) + rho_pi * (pi-pi_targer) + rho_y * (GDP - GDP_ss)) + shock_mon;//45 pi
//R_CB = R_D * pi(1);//  pi



///////////////////////////////////////////////////////////////////////
// Market clearing
///////////////////////////////////////////////////////////////////////

N = Nn + No; //46
GDP =   Y_H + P_oil * Y_oil ;//47   
Y_H +  P_oil * Y_oil +  R_star  * F(-1)     = C + phi_func * X + alpha_oil * P_oil * Y_oil + G  + (F - F(-1))   ; //48 P_no
G = G_p + G_c ; //49
//prof_total = prof_K + prof_D + prof_L ; //50
R = (1-u)* R_k* P_k(-1) -(1-delta_k)* P_k ; //50 
prof_R =   Y_H - P_no * Y_no ; //51
%%%%
 // processes  
///////////////////////////////////////////////////////////////////////
eps1= rho_eps1 * eps1(-1) + ue1;                                     // Tech shock process 52
eps2= rho_eps2 * eps2(-1) + ue2;                                     // Tech shock process 53
shock_oil = rho_shock_oil * shock_oil(-1) + u_oil; //54
shock_mon = rho_mon * shock_mon(-1) + u_mon ; //55
pi_targer =  (1-rho_pitarget)* pi_ss + rho_pitarget * pi_targer(-1) + u_pitarget; //56
/////

end;
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// initialize the different variables at their steady state
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load SS_oil_init.mat 
initval;

P_k = P_k_ss; prof_K = prof_K_ss;  Y_no = Y_no_ss; Nn = Nn_ss;  No = No_ss;
K = K_ss; L = L_ss; W = W_ss;     X = X_ss; P_no=P_no_ss; prof_R=prof_R_ss;
x = 1; 
R_D = R_D_ss;  R_IB = R_IB_ss; R = R_ss; R_CB = R_CB_ss; R_star = R_star_ss; R_k = R_k_ss; R_B = R_B_ss;   
 
Y_H = Y_H_ss; C = C_ss; B = B_ss; G = G_ss; G_c = G_c_ss;   G_p = G_p_ss; trans = trans_ss; T = T_ss; S = S_ss;  
NW = NW_ss; prof_L = prof_L_ss; prof_D = prof_D_ss;
P_oil = P_oil_ss; Y_oil = Y_oil_ss; K_oil = K_oil_ss;  No = No_ss; W_oil = W_oil_ss; OR = OR_ss;
N = N_ss; D = D_ss;  B_CB = B_CB_ss; K_G = K_G_ss;    R=R_ss;

phi_func = phi_func_ss;
phi_func_der = phi_func_der_ss;

X1 = X1_ss ; X2 = X2_ss; X3 = X3_ss;  
F =  F_ss; pi = pi_ss;   GDP = GDP_ss; mc=mc_ss ; lambda_C=lambda_C_ss;  pistar=pistar_ss;

eps1 =0; eps2 =0;   shock_oil = 0;   ue1=0; ue2=0;  u_oil=0;  

end;

clear SS_oil_init.mat 


write_latex_dynamic_model;
write_latex_static_model;

resid;
steady ;
check;

//steady(solve_algo = 4,maxit=1000);
//model_diagnostics(M_,options_,oo_)
//model_info;


shocks; 
var u_oil   ; stderr 0.01 ; 
//var ue1     ; stderr 0.01; 
//var ue1     ; stderr 0.01; 
//var u_mon     ;stderr 0.01 ; 
//var u_pitarget;stderr 0.01 ; 



end;
// order 1=  At first order they are deviations from the steady state.
// with relative_irf= relative_irf only normalizes the variables by the shock size so that the shock sizes are comparable. It does not rescale the other variables by their steady state values to make them percentage deviations!
// order 2 et + = % deviation 

stoch_simul(periods=2100,irf = 40 ,order =1);
//stoch_simul(order=1, irf=20) ; GDP  Y_no Y_oil Y_M K K_oil NW P_no R W  R_k R_CB Q pi Nn No N shock_oil; // eps1 eps3 shock_oil;
// close;

//save('bgg','oo_','M_')
//save('nobgg','oo_','M_')
//save('norottem','oo_','M_')
//save('noCapCost','oo_','M_')
//save('basel1','oo_','M_')
//model_diagnostics(M_,options_,oo_)